/*********************************************************************

 Author        : ADI - Apps            www.analog.com/MicroConverter

 Date          : Dec. 2006

 File          : UART1.c

 Hardware      : Applicable to ADuC703x

 Description   : This code demonstrates basic UART functionality.
				 The baudrate is calculated with the following formula:
				 	Baudrate = 20480000 / ( 2^CD * 16 * 2 * DL )
 					CD = 0 in this example
					
				Baudrate = 9600bps		   
                                          																   
***********************************************************************/

#include <ADuC7033.h>
 	
extern int write (int file, unsigned char * ptr, int len);	// Functions used to 
extern int getchar (void);							// to output data 	 
extern int putchar(int);                     		// Write character to Serial Port  


int main (void)  
{
	unsigned char jchar = 0x30;

	unsigned char output1[13] = "Hello World\n";
	
	GP1CON = 0x011;
	GP2DAT = 0x02000000;		// Enable P2.1 (GPIO8) as an output

	POWKEY0 = 0x1;
	POWCON = 0x78;				// CD = 0
	POWKEY1 = 0xF4;

  	COMCON0 = 0x80;				// Setting DLAB
	COMDIV0 = 0x43;				// 9600 bps
   	COMDIV1 = 0x00;
   	COMCON0 = 0x07;				// Clearing DLAB
	COMCON1 = 0x80;

	while(1)
	{
		GP2DAT ^=0x020000;		// Complement P2.1
		write(0,output1,13);	// Output Data
		jchar = getchar();		// RX Data, Single Byte
		write(0,&jchar,1);		// Output Rxed Data
	}
}
